packer {
  required_plugins {
    proxmox = {
      version = "1.1.6"
      source  = "github.com/hashicorp/proxmox"
    }
  }
}

locals {
  current_date = formatdate("YYYY-MM-DD", timestamp())
}

source "proxmox-iso" "ubuntu22-template" {
  # --- Proxmox Config ---
  proxmox_url               = "${var.proxmox_hostname}/api2/json"
  username                  = var.proxmox_username
  password                  = var.proxmox_password
  node                      = var.proxmox_node_name
  insecure_skip_tls_verify  = var.proxmox_insecure_skip_tls_verify

  # --- ISO Config ---
  iso_file              = "local:iso/ubuntu-22.04.4-live-server-amd64.iso"
  iso_checksum          = "md5:125022ADDBE20D3A9E3B71E04653F67B"
  iso_storage_pool      = "local-lvm"  # where to upload the iso file
  unmount_iso           = true

  # --- VM Config ---
  vm_id                 = 104
  vm_name               = "ubuntu-server-22-04-amd64"
  template_name         = "ubuntu-server-22-04-amd64"
  template_description  = "Ubuntu Server 22.04 (Template Generated by Packer) - ${local.current_date}"
  tags                  = "ubuntu-server-22-04-amd64"
  sockets               = 1
  cores                 = 2
  memory                = 2048
  os                    = "l26"
  onboot                = true  # VM starts automatically when hypervisor starts up
  qemu_agent            = true  # Allows VM to provide information to hypervisor
  disable_kvm           = false # Do not disable KVM hardware virtualization

  # --- Network Config ---
  network_adapters {
    bridge   = "vmbr0"
    model    = "virtio"
    firewall = false
    packet_queues = 0  # Can set to number of cpus for better network performance (eg. reverse proxy)
  }

  # --- Disk Config ---
  disks {
    type              = "virtio"
    disk_size         = "10G"
    storage_pool      = "local-lvm"
    # "qcow2" offers snapshot and thin provisioning. "raw" is thick provisioning with best performance.
    # Seems to have a bug with qcow2: https://github.com/hashicorp/packer-plugin-proxmox/issues/92
    format            = "raw"
    io_thread         = true
  }
  # virtio-scsi-single: new controller for each disk
  # virtio-scsi-pci: all disks on same controller
  scsi_controller       = "virtio-scsi-single"

  # --- Boot Config ---
  boot = "order=virtio0;ide2;net0"  # Boot disk, CD, network
  machine               = "q35"     # Only ide0 and ide2 are available in q35
  http_directory        = "./http"  # Set up http directory (IP and port available as variables in boot command)
  http_port_min         = var.http_port
  http_port_max         = var.http_port

  # --- ovmf ---
  bios                  = "ovmf"
  boot_wait             = "7s"
  boot_command          = [
    "e<wait>",
    "<down><down><down><end>",
    "<bs><bs><bs><bs>",
    #"autoinstall ds='nocloud-net;s=http://{{ .HTTPIP }}:{{ .HTTPPort }}/' ---",
    "autoinstall ds='nocloud-net;s=http://${var.http_ip}:{{ .HTTPPort }}/' ---",
    "<f10>"
  ]
  efi_config {
    efi_storage_pool    = "local-lvm"
    efi_type            = "4m"
    pre_enrolled_keys   = false
  }

  # --- seabios (not working)---
  # bios                  = "seabios"
  # boot_wait             = "2s"
  # boot_command          = [
  #   "<esc><wait><esc><wait><f6><wait><esc><wait>",
  #   "<f6><wait><esc><wait>",
  #   "<bs><bs><bs><bs>",
  #   "autoinstall ds='nocloud-net;s=http://{{ .HTTPIP }}:{{ .HTTPPort }}/' ---",
  #   "<enter>"
  # ]

  # --- Cloudinit Config ---
  cloud_init              = false  # Remove cloud init cdrom drive after VM conversion to template 
                                   # https://github.com/Telmate/terraform-provider-proxmox/issues/704#issuecomment-1645291953
  cloud_init_storage_pool = "local-lvm"

  # --- terminal needed for sudo ---
  ssh_pty               = true
  ssh_username          = "ubuntu"
  ssh_password          = "ubuntu"
  ssh_timeout           = "35m"
}

build {
  sources = [
    "source.proxmox-iso.ubuntu22-template"
  ]

  # Wait for cloud-init to complete
  provisioner "shell" {
    inline = [
      "sudo cloud-init status --wait",
    ]
  }

  # Cannot copy directly to privileged file paths
  provisioner "file" {
    source = "${path.root}/files/auto_resize_vda.sh"
    destination = "/tmp/auto_resize_vda.sh"
  }
  provisioner "shell" {
    inline = [
      "sudo mv /tmp/auto_resize_vda.sh /etc/auto_resize_vda.sh",
      "sudo chmod u+x /etc/auto_resize_vda.sh",
    ]
  }

  # Run post-provisioning scripts
  provisioner "shell" {
    environment_vars = [
      "DEBIAN_FRONTEND=noninteractive",
    ]
    scripts = [
      "${path.root}/scripts/install.sh",
      "${path.root}/scripts/cloudinit_preparation.sh",
      "${path.root}/scripts/clean.sh",
    ]
  }
}
